Index: branches/2017/dev_CNRS_2017/DOC/TexFiles/Chapters/Chap_DOM.tex
===================================================================
--- branches/2017/dev_CNRS_2017/DOC/TexFiles/Chapters/Chap_DOM.tex	(revision 8938)
+++ branches/2017/dev_CNRS_2017/DOC/TexFiles/Chapters/Chap_DOM.tex	(revision 8969)
@@ -406,57 +406,4 @@
 
 
-CAUTION! This part need to be rewritten! no jphgr\_mesh anymore 
-
-The user has three options available in defining a horizontal grid, which involve 
-the namelist variable \np{jphgr\_mesh} of the \ngn{namcfg} namelist. 
-\begin{description}
-\item[\np{jphgr\_mesh}=0]  The most general curvilinear orthogonal grids.
-The coordinates and their first derivatives with respect to $i$ and $j$ are provided
-in a input file (\ifile{coordinates}), read in \rou{hgr\_read} subroutine of the domhgr module.
-\item[\np{jphgr\_mesh}=1 to 5] A few simple analytical grids are provided (see below). 
-For other analytical grids, the \mdl{domhgr} module must be modified by the user. 
-\end{description}
-
-There are two simple cases of geographical grids on the sphere. With 
-\np{jphgr\_mesh}=1, the grid (expressed in degrees) is regular in space, 
-with grid sizes specified by parameters \np{ppe1\_deg} and \np{ppe2\_deg}, 
-respectively. Such a geographical grid can be very anisotropic at high latitudes 
-because of the convergence of meridians (the zonal scale factors $e_1$ 
-become much smaller than the meridional scale factors $e_2$). The Mercator 
-grid (\np{jphgr\_mesh}=4) avoids this anisotropy by refining the meridional scale 
-factors in the same way as the zonal ones. In this case, meridional scale factors 
-and latitudes are calculated analytically using the formulae appropriate for 
-a Mercator projection, based on \np{ppe1\_deg} which is a reference grid spacing 
-at the equator (this applies even when the geographical equator is situated outside 
-the model domain). 
-%%%
-\gmcomment{ give here the analytical expression of the Mercator mesh}
-%%%
-In these two cases (\np{jphgr\_mesh}=1 or 4), the grid position is defined by the 
-longitude and latitude of the south-westernmost point (\np{ppglamt0} 
-and \np{ppgphi0}). Note that for the Mercator grid the user need only provide 
-an approximate starting latitude: the real latitude will be recalculated analytically, 
-in order to ensure that the equator corresponds to line passing through $t$- 
-and $u$-points.  
-
-Rectangular grids ignoring the spherical geometry are defined with 
-\np{jphgr\_mesh} = 2, 3, 5. The domain is either an $f$-plane (\np{jphgr\_mesh} = 2, 
-Coriolis factor is constant) or a beta-plane (\np{jphgr\_mesh} = 3, the Coriolis factor 
-is linear in the $j$-direction). The grid size is uniform in meter in each direction, 
-and given by the parameters \np{ppe1\_m} and \np{ppe2\_m} respectively. 
-The zonal grid coordinate (\textit{glam} arrays) is in kilometers, starting at zero 
-with the first $t$-point. The meridional coordinate (gphi. arrays) is in kilometers, 
-and the second $t$-point corresponds to coordinate $gphit=0$. The input 
-variable \np{ppglam0} is ignored. \np{ppgphi0} is used to set the reference 
-latitude for computation of the Coriolis parameter. In the case of the beta plane, 
-\np{ppgphi0} corresponds to the center of the domain. Finally, the special case 
-\np{jphgr\_mesh}=5 corresponds to a beta plane in a rotated domain for the 
-GYRE configuration, representing a classical mid-latitude double gyre system. 
-The rotation allows us to maximize the jet length relative to the gyre areas 
-(and the number of grid points). 
-
-The choice of the grid must be consistent with the boundary conditions specified 
-by \np{jperio}, a parameter found in \ngn{namcfg} namelist (see {\S\ref{LBC}).
-
 % -------------------------------------------------------------------------------------------------------------
 %        Grid files
@@ -646,5 +593,5 @@
 (Fig.~\ref{Fig_zgr}).
 
-If the ice shelf cavities are opened (\np{ln\_isfcav}=~true~}), the definition of $z_0$ is the same. 
+If the ice shelf cavities are opened (\np{ln\_isfcav}=~true~), the definition of $z_0$ is the same. 
 However, definition of $e_3^0$ at $t$- and $w$-points is respectively changed to:
 \begin{equation} \label{DOM_zgr_ana}