Index: branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 9007)
+++ branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 9008)
@@ -24,4 +24,5 @@
    USE sms_medusa      ! sms trends
    USE iom             ! I/O manager
+   USE sbc_oce, ONLY: lk_oasis
    !!USE trc_nam_dia     ! JPALM 13-11-2015 -- if iom_use for diag
 
@@ -919,40 +920,44 @@
          WRITE(numout,*) '=== UKESM1-related parameters ==='
          WRITE(numout,*) ' ---- --- ---'
-         WRITE(numout,*) '=== UKESM1 --  coupled DMS to the UM'
-         WRITE(numout,*)     &
-         &   ' include DMS diagnostic?,                                   jdms        = ', jdms
-         if (jdms_input .eq. 0) then
-            WRITE(numout,*)     &
-            &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = instantaneous'
-         else
-            WRITE(numout,*)     &
-            &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = diel-average'
-         endif
-	 if (jdms_model .eq. 1) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001)'
-	 elseif (jdms_model .eq. 2) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Simo & Dachs (2002)'
-	 elseif (jdms_model .eq. 3) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Aranami & Tsunogai (2004)'
-	 elseif (jdms_model .eq. 4) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Halloran et al. (2010)'
-	 elseif (jdms_model .eq. 5) then
-            WRITE(numout,*)     &
-            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001; modified)'
-         endif
-         WRITE(numout,*) '=== UKESM1 --  coupled Chl to the UM'
-         WRITE(numout,*)        &
-            &   ' Scaling factor to export tuned Chl to the UM               scl_chl  = ', scl_chl
-         IF (chl_out .eq. 1) THEN
+
+         IF (lk_oasis) THEN
+            WRITE(numout,*) '=== UKESM1 --  coupled DMS to the atmosphere'
+            WRITE(numout,*)     &
+            &   ' include DMS diagnostic?,                                   jdms        = ', jdms
+            if (jdms_input .eq. 0) then
+               WRITE(numout,*)     &
+               &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = instantaneous'
+            else
+               WRITE(numout,*)     &
+               &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = diel-average'
+            endif
+   	    if (jdms_model .eq. 1) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001)'
+	    elseif (jdms_model .eq. 2) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Simo & Dachs (2002)'
+	    elseif (jdms_model .eq. 3) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Aranami & Tsunogai (2004)'
+	    elseif (jdms_model .eq. 4) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Halloran et al. (2010)'
+	    elseif (jdms_model .eq. 5) then
+               WRITE(numout,*)     &
+               &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001; modified)'
+            endif
+         
+            WRITE(numout,*) '=== UKESM1 --  coupled Chl to the atmosphere'
             WRITE(numout,*)        &
-            &   ' Chl field to be scaled and sent to the UM:                 chl_out  = Surface Chl field '
-         ELSEIF (chl_out .eq. 2) THEN
-            WRITE(numout,*)        &
-            &   ' Chl field to be scaled and sent to the UM:                 chl_out  = MLD Chl field '
-         ENDIF
+               &   ' Scaling factor to export tuned Chl to the atmosphere       scl_chl  = ', scl_chl
+            IF (chl_out .eq. 1) THEN
+               WRITE(numout,*)        &
+               &   ' Chl field to be scaled and sent to the atmosphere:         chl_out  = Surface Chl field '
+            ELSEIF (chl_out .eq. 2) THEN
+               WRITE(numout,*)        &
+               &   ' Chl field to be scaled and sent to the atmosphere:         chl_out  = MLD Chl field '
+            ENDIF
+         ENDIF ! IF lk_oasis=true
 !!
       ENDIF
Index: branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 9007)
+++ branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 9008)
@@ -277,7 +277,8 @@
       !!                     as proxy of org matter from the ocean
       !!                  -- needed for the coupling with atm
-      !!       07-12-2017 -- To make things cleaner we want to pass ans read an 
-      !!                     unscaled Chl field to the restart and scale it when
-      !!                     reading it.
+      !!       07-12-2017 -- To make things cleaner, we want to store an  
+      !!                     unscaled Chl field in the restart and only 
+      ||                     scale it when reading it in.
+
       IF( iom_varid( numrtr, 'N_CHL_srf', ldstop = .FALSE. ) > 0 ) THEN
          IF(lwp) WRITE(numout,*) 'Chl cpl concentration - reading in ... - scale by ', scl_chl
@@ -461,7 +462,7 @@
       CALL iom_rstput( kt, nitrst, numrtw, 'B_CO2_flx',  zb_co2_flx(:,:)  )
       CALL iom_rstput( kt, nitrst, numrtw, 'N_CO2_flx',  zn_co2_flx(:,:)  )
-      !! JPALM 07-12-2017 -- To make things cleaner we want to pass ans read an 
-      !!                     unscaled Chl field to the restart and scale it when
-      !!                     reading it.
+      !! JPALM 07-12-2017 -- To make things cleaner, we want to store an  
+      !!                     unscaled Chl field in the restart and only 
+      ||                     scale it when reading it in.
       zn_chl_srf(:,:) = zn_chl_srf(:,:) / scl_chl 
       CALL iom_rstput( kt, nitrst, numrtw, 'N_CHL_srf',  zn_chl_srf(:,:)  )