Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90	(revision 9015)
@@ -120,5 +120,5 @@
       !!--------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('ice_forcing')
+      IF( nn_timing == 1 )   CALL timing_start('ice_forcing_flx')
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -165,5 +165,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )   CALL timing_stop('ice_forcing')
+      IF( nn_timing == 1 )   CALL timing_stop('ice_forcing_flx')
       !
    END SUBROUTINE ice_forcing_flx
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/icethd_pnd.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/icethd_pnd.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/icethd_pnd.F90	(revision 9015)
@@ -59,6 +59,4 @@
       !!-------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('ice_thd_pnd')
-
       SELECT CASE ( nice_pnd )
 
@@ -72,6 +70,4 @@
          !                             !-------------------------------!
       END SELECT
-
-      IF( nn_timing == 1 )  CALL timing_stop('ice_thd_pnd')
 
    END SUBROUTINE ice_thd_pnd 
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 9015)
@@ -338,5 +338,5 @@
       !!---------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('ice_update')
+      IF( nn_timing == 1 )  CALL timing_start('ice_update_tau')
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -384,5 +384,5 @@
       CALL lbc_lnk_multi( utau, 'U', -1., vtau, 'V', -1. )   ! lateral boundary condition
       !
-      IF( nn_timing == 1 )  CALL timing_stop('ice_update')
+      IF( nn_timing == 1 )  CALL timing_stop('ice_update_tau')
       !  
    END SUBROUTINE ice_update_tau
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 9015)
@@ -249,6 +249,4 @@
       !  
       CALL bdy_orlanski_2d( idx, igrd, pvb2d, pva2d, dta%v2d, ll_npo )
-      !
-      IF( nn_timing == 1 ) CALL timing_stop('bdy_dyn2d_orlanski')
       !
       CALL lbc_bdy_lnk( pua2d, 'U', -1., ib_bdy )   ! Boundary points should be updated
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90	(revision 9015)
@@ -103,5 +103,5 @@
       !!------------------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('bdy_ice_frs')
+      IF( ln_timing )   CALL timing_start('bdy_ice_frs')
       !
       jgrd = 1      ! Everything is at T-points here
@@ -255,5 +255,5 @@
       IF( jpl > 1 )   CALL ice_itd_reb( kt )
       !      
-      IF( nn_timing == 1 )   CALL timing_stop('bdy_ice_frs')
+      IF( ln_timing )   CALL timing_stop('bdy_ice_frs')
       !
    END SUBROUTINE bdy_ice_frs
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 9015)
@@ -250,4 +250,6 @@
       CALL wrk_dealloc( jpi,jpj,jpk,   ze3t, ze3u, ze3v, ze3w )
       !
+      IF( nn_timing == 1 )  CALL timing_stop('crs_init')
+      !
    END SUBROUTINE crs_init
     
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90	(revision 9015)
@@ -380,5 +380,5 @@
       !IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (update hdivn field)
       !
-      IF( ln_timing )  CALL timing_stop('wad_lmt')
+      IF( ln_timing )  CALL timing_stop('wad_lmt_bt')
       !
    END SUBROUTINE wad_lmt_bt
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk.F90	(revision 9015)
@@ -1008,5 +1008,5 @@
       !!---------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('blk_ice_qcn')
+      IF( ln_timing )  CALL timing_start('blk_ice_qcn')
       
       ! -------------------------------------!
@@ -1070,5 +1070,5 @@
       END DO 
       !      
-      IF( nn_timing == 1 )  CALL timing_stop('blk_ice_qcn')
+      IF( ln_timing )  CALL timing_stop('blk_ice_qcn')
       !
    END SUBROUTINE blk_ice_qcn
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfosm.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfosm.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfosm.F90	(revision 9015)
@@ -253,5 +253,5 @@
       !!--------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('zdf_osm')
+      IF( ln_timing )  CALL timing_start('zdf_osm')
       !
       ALLOCATE( lconv(jpi,jpj),  STAT= i_lconv_alloc )
@@ -1352,4 +1352,6 @@
       CALL lbc_lnk( p_avt(:,:,:), 'W', 1. )
       !
+      IF( ln_timing )  CALL timing_stop('zdf_osm')
+      !
    END SUBROUTINE zdf_osm
 
@@ -1375,5 +1377,5 @@
      !!----------------------------------------------------------------------
      !
-     IF( nn_timing == 1 )  CALL timing_start('zdf_osm_init')
+     IF( ln_timing )  CALL timing_start('zdf_osm_init')
      !
      REWIND( numnam_ref )              ! Namelist namzdf_osm in reference namelist : Osmosis ML model
@@ -1503,5 +1505,5 @@
 
      !
-     IF( nn_timing == 1 )  CALL timing_stop('zdf_osm_init')
+     IF( ln_timing )  CALL timing_stop('zdf_osm_init')
      !
    END SUBROUTINE zdf_osm_init
@@ -1614,5 +1616,5 @@
       INTEGER :: ji, jj, jk
       !
-      IF( nn_timing == 1 )  CALL timing_start('tra_osm')
+      IF( ln_timing )  CALL timing_start('tra_osm')
       !
       IF( kt == nit000 ) THEN
@@ -1657,5 +1659,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('tra_osm')
+      IF( ln_timing )  CALL timing_stop('tra_osm')
       !
    END SUBROUTINE tra_osm
@@ -1693,5 +1695,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('dyn_osm')
+      IF( ln_timing )  CALL timing_start('dyn_osm')
       !
       IF( kt == nit000 ) THEN
@@ -1717,5 +1719,5 @@
       ! code for saving tracer trends removed
       !
-      IF( nn_timing == 1 )  CALL timing_stop('dyn_osm')
+      IF( ln_timing )  CALL timing_stop('dyn_osm')
       !
    END SUBROUTINE dyn_osm
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 9015)
@@ -423,5 +423,5 @@
       !                                      ! Domain decomposition
       CALL mpp_init
-      IF( ln_nnogather )    CALL nemo_northcomms! northfold neighbour lists (must be done after the masks are defined)
+      IF( ln_nnogather )   CALL nemo_northcomms! northfold neighbour lists
       !
       IF( ln_timing    )   CALL timing_init
@@ -434,5 +434,4 @@
                            CALL     dom_init   ! Domain
       IF( ln_crs       )   CALL     crs_init   ! coarsened grid: domain initialization 
-      !IF( ln_nnogather )    CALL nemo_northcomms! northfold neighbour lists (must be done after the masks are defined)
       IF( ln_ctl       )   CALL prt_ctl_init   ! Print control
       
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 9015)
@@ -222,5 +222,5 @@
          !
       ENDIF
-      IF( nn_timing == 1 )  CALL timing_stop('trc_dmp_init')
+      IF( nn_timing == 1 )  CALL timing_stop('trc_dmp_ini')
       !
    END SUBROUTINE trc_dmp_ini
Index: branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 9012)
+++ branches/2017/dev_CNRS_2017/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 9015)
@@ -286,5 +286,5 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_start('trc_sub_stp')
+      IF( nn_timing == 1 )  CALL timing_stop('trc_sub_stp')
       !
    END SUBROUTINE trc_sub_stp