Index: branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_CFG.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_CFG.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_CFG.tex	(revision 9019)
@@ -25,7 +25,4 @@
 in the code, though by no means are all options exercised in the reference configurations.
 
-Configuration is defined mainly through the \ngn{namcfg}  namelist variables:
-\sfcomment {Here change namcfg part of namelist. Configuration is defined throughout domain\_cfg.nc file now}  
-
 %------------------------------------------namcfg----------------------------------------------------
 \namdisplay{namcfg}
@@ -37,4 +34,8 @@
 \section{Water column model: 1D model (C1D) (\key{c1d}) }
 \label{CFG_c1d}
+
+$\ $\newline
+BE careful: to be re-written according to suppression of jpizoom and jpjzoom !!!!
+$\ $\newline
 
 The 1D model option simulates a stand alone water column within the 3D \NEMO system. 
@@ -85,8 +86,9 @@
 the LIM sea-ice model (ORCA-LIM) and possibly with PISCES biogeochemical model 
 (ORCA-LIM-PISCES), using various resolutions.
-The appropriate namelist is available in \textit{CONFIG/ORCA2\_LIM3\_PISCES/EXP00/namelist\_cfg} 
-for ORCA2 and in \textit{CONFIG/SHARED/README\_configs\_namcfg\_namdom}  \sfcomment {not really true, they are obsolete namelists, where find these informations?}  
-for other resolutions
-
+An appropriate namelist is available in \textit{CONFIG/ORCA2\_LIM3\_PISCES/EXP00/namelist\_cfg} 
+for ORCA2.
+The domain of ORCA2 configuration is defined in ORCA\_R2\_zps\_domcfg.nc file, this file is available in tar file in the wiki of NEMO : \\
+https://forge.ipsl.jussieu.fr/nemo/wiki/Users/ReferenceConfigurations/ORCA2\_LIM3\_PISCES \\
+In this namelist\_cfg the name of domain input file is set in \ngn{namcfg} block of namelist. 
 
 %>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -140,6 +142,6 @@
 than the smallest one in the southern hemisphere.
 The resulting mesh is shown in Fig.~\ref{Fig_MISC_ORCA_msh} and \ref{Fig_MISC_ORCA_e1e2} 
-for a half a degree grid (ORCA\_R05). The smallest ocean scale factor is found in along  
-Antarctica, while the ratio of anisotropy remains close to one except near the Victoria Island 
+for a half a degree grid (ORCA\_R05).
+The smallest ocean scale factor is found in along  Antarctica, while the ratio of anisotropy remains close to one except near the Victoria Island 
 in the Canadian Archipelago. 
 
@@ -153,7 +155,6 @@
 The NEMO system is provided with five built-in ORCA configurations which differ in the 
 horizontal resolution. The value of the resolution is given by the resolution at the Equator 
-expressed in degrees. Each of configuration is set through the \textit{domain\_cfg} file, 
-which sets the grid size and configuration name parameters \sfcomment {I would like to change tab_ORCA but I can not find it, wrong jp_cfg}  
- (Tab. \ref{Tab_ORCA}).
+expressed in degrees. Each of configuration is set through the \textit{domain\_cfg} domain configuration file, 
+which sets the grid size and configuration name parameters. The NEMO System Team provides only ORCA2 domain input file "ORCA\_R2\_zps\_domcfg.nc" file  (Tab. \ref{Tab_ORCA}).
 
 
@@ -175,6 +176,6 @@
 \end{tabular}
 \caption{ \label{Tab_ORCA}   
-Set of predefined parameters for ORCA family configurations.
-In all cases, the flag for configurations of ORCA family is set to 1 in \textit{domain\_cfg}  }
+Domain size of ORCA family configurations.
+The flag for configurations of ORCA family need to be set in \textit{domain\_cfg} file. }
 \end{center}
 \end{table}
Index: branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_DOM.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_DOM.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_DOM.tex	(revision 9019)
@@ -268,6 +268,5 @@
 
 The total size of the computational domain is set by the parameters \np{jpiglo}, 
-\np{jpjglo} and \np{jpkglo} in the $i$, $j$ and $k$ directions respectively. They are 
-given as namelist variables in the \ngn{namcfg} namelist. 
+\np{jpjglo} and \np{jpkglo} in the $i$, $j$ and $k$ directions respectively. 
 %%%
 %%%
@@ -278,18 +277,4 @@
 
 $\ $\newline    % force a new line
-
-%%%
-\sfcomment {Hereafter I want to create new subsection 4.2: "fields needed by opa engine or something like this"
-and add list of fields :
-case 1: read in domain.nc
-case 2: defined in userdef\_hrg\/zgr.F90
-longitude, latitude, domaine size 
-number of points
-factor scales (e1, e2, e3)
-coriolis
-k\_top, k\_bottom (first and last ocean level)
-periodicity
-}
-%%%
 
 % ================================================================
@@ -303,55 +288,29 @@
 The grid-points are located at integer or integer and a half values of as indicated 
 in Table~\ref{Tab_cell}. The associated scale factors are defined using the  
-analytical first derivative of the transformation \eqref{Eq_scale_factors}. These 
-definitions are done in two modules given by example, \mdl{userdef\_hgr} and \mdl{userdef\_zgr}, which 
-provide the horizontal and vertical meshes, respectively. Otherwise all needed fields can be read in file \np{cn\_domcfg} specified in \ngn{namcfg}.
+analytical first derivative of the transformation \eqref{Eq_scale_factors}. 
+Necessary fields for configuration definition are: \\
+Geographic position :
+
+longitude : glamt , glamu , glamv and glamf  (at T, U, V and F point)
+
+latitude : gphit , gphiu , gphiv and gphif (at T, U, V and F point)\\
+Coriolis parameter (if domain not on the sphere): 
+
+ ff\_f  and  ff\_t (at T and F point)\\
+Scale factors : 
  
-The needed fields for domain are: 
-
-geographic position :
-
-longitude : glamt , glamu , glamv and glamf  (at T, U, V and F point)
-
-latitude : gphit , gphiu , gphiv and gphif (at T, U, V and F point)
-
-Coriolis parameter (if domain not on the sphere):  ff\_f  and  ff\_t (at T and F point)
-
-Scale factors : e1t, e1u, e1v and e1f (on i direction),
-
-   e2t, e2u, e2v and e2f (on j direction)
-
-   and ie1e2u\_v, e1e2u , e1e2v   
-
-%%%
-\sfcomment {
-say something about ie1e2u\_v, e1e2u , e1e2v
-
-and add list of fields :
-case 1: read in domain.nc
-case 2: defined in userdef\_hrg\/zgr.F90
-longitude, latitude, domaine size
-number of points
-factor scales (e1, e2, e3)
-coriolis
-k\_top, k\_bottom (first and last ocean level)
-periodicity
-----
-        int ORCA ;
-   int ORCA\_index ;
-   int jpiglo ; j, k
-   int jperio ;
-   int ln_zco ; zps, sco
-   int ln_isfcav ;
-   double glamt(t, y, x) ; u,v,f
-   double gphit(t, y, x) ; u,v,f
-   double e1t(t, y, x) ; u,v,w,
-   double e2t(t, y, x) ; u,v,w
-   double ff\_f(t, y, x) ;  double ff\_t(t, y, x) ;
-   double e3t\_1d(t, z) ;
-   double e3w\_1d(t, z) ;
-   double e3t\_0(t, z, y, x) ; u0, v0 , w0
-----
-}
-
+ e1t, e1u, e1v and e1f (on i direction),
+
+ e2t, e2u, e2v and e2f (on j direction)
+
+ and ie1e2u\_v, e1e2u , e1e2v   
+ 
+e1e2u , e1e2v are u and v surfaces (if gridsize reduction in some straits)\\
+ie1e2u\_v is a flag to flag set u and  v surfaces are neither read nor computed.\\
+ 
+These fields can be read in an domain input file which name is setted in \np{cn\_domcfg} parameter specified in \ngn{namcfg}.
+\namdisplay{namcfg}
+or they can be defined in an analytical way in MY\_SRC directory of the configuration.
+For Reference Configurations of NEMO input domain files are supplied by NEMO System Team. For analytical definition of input fields two routines are supplied: \mdl{userdef\_hgr} and \mdl{userdef\_zgr}. They are an example of GYRE configuration parameters, and they are available in NEMO/OPA\_SRC/USR directory, they provide the horizontal and vertical mesh. 
 % -------------------------------------------------------------------------------------------------------------
 %        Needed fields 
@@ -446,54 +405,4 @@
 \label{DOM_hgr_msh_choice}
 
-The user has three options available in defining a horizontal grid, which involve 
-the namelist variable \np{jphgr\_mesh} of the \ngn{namcfg} namelist. 
-\begin{description}
-\item[\np{jphgr\_mesh}=0]  The most general curvilinear orthogonal grids.
-The coordinates and their first derivatives with respect to $i$ and $j$ are provided
-in a input file (\ifile{coordinates}), read in \rou{hgr\_read} subroutine of the domhgr module.
-\item[\np{jphgr\_mesh}=1 to 5] A few simple analytical grids are provided (see below). 
-For other analytical grids, the \mdl{domhgr} module must be modified by the user. 
-\end{description}
-
-There are two simple cases of geographical grids on the sphere. With 
-\np{jphgr\_mesh}=1, the grid (expressed in degrees) is regular in space, 
-with grid sizes specified by parameters \np{ppe1\_deg} and \np{ppe2\_deg}, 
-respectively. Such a geographical grid can be very anisotropic at high latitudes 
-because of the convergence of meridians (the zonal scale factors $e_1$ 
-become much smaller than the meridional scale factors $e_2$). The Mercator 
-grid (\np{jphgr\_mesh}=4) avoids this anisotropy by refining the meridional scale 
-factors in the same way as the zonal ones. In this case, meridional scale factors 
-and latitudes are calculated analytically using the formulae appropriate for 
-a Mercator projection, based on \np{ppe1\_deg} which is a reference grid spacing 
-at the equator (this applies even when the geographical equator is situated outside 
-the model domain). 
-%%%
-\gmcomment{ give here the analytical expression of the Mercator mesh}
-%%%
-In these two cases (\np{jphgr\_mesh}=1 or 4), the grid position is defined by the 
-longitude and latitude of the south-westernmost point (\np{ppglamt0} 
-and \np{ppgphi0}). Note that for the Mercator grid the user need only provide 
-an approximate starting latitude: the real latitude will be recalculated analytically, 
-in order to ensure that the equator corresponds to line passing through $t$- 
-and $u$-points.  
-
-Rectangular grids ignoring the spherical geometry are defined with 
-\np{jphgr\_mesh} = 2, 3, 5. The domain is either an $f$-plane (\np{jphgr\_mesh} = 2, 
-Coriolis factor is constant) or a beta-plane (\np{jphgr\_mesh} = 3, the Coriolis factor 
-is linear in the $j$-direction). The grid size is uniform in meter in each direction, 
-and given by the parameters \np{ppe1\_m} and \np{ppe2\_m} respectively. 
-The zonal grid coordinate (\textit{glam} arrays) is in kilometers, starting at zero 
-with the first $t$-point. The meridional coordinate (gphi. arrays) is in kilometers, 
-and the second $t$-point corresponds to coordinate $gphit=0$. The input 
-variable \np{ppglam0} is ignored. \np{ppgphi0} is used to set the reference 
-latitude for computation of the Coriolis parameter. In the case of the beta plane, 
-\np{ppgphi0} corresponds to the center of the domain. Finally, the special case 
-\np{jphgr\_mesh}=5 corresponds to a beta plane in a rotated domain for the 
-GYRE configuration, representing a classical mid-latitude double gyre system. 
-The rotation allows us to maximize the jet length relative to the gyre areas 
-(and the number of grid points). 
-
-The choice of the grid must be consistent with the boundary conditions specified 
-by \np{jperio}, a parameter found in \ngn{namcfg} namelist (see {\S\ref{LBC}).
 
 % -------------------------------------------------------------------------------------------------------------
@@ -684,5 +593,5 @@
 (Fig.~\ref{Fig_zgr}).
 
-If the ice shelf cavities are opened (\np{ln\_isfcav}=~true~}), the definition of $z_0$ is the same. 
+If the ice shelf cavities are opened (\np{ln\_isfcav}=~true~), the definition of $z_0$ is the same. 
 However, definition of $e_3^0$ at $t$- and $w$-points is respectively changed to:
 \begin{equation} \label{DOM_zgr_ana}
@@ -737,5 +646,5 @@
 \begin{table}     \begin{center} \begin{tabular}{c||r|r|r|r}
 \hline
-\textbf{LEVEL}& \textbf{gdept}& \textbf{gdepw}& \textbf{e3t }& \textbf{e3w  } \\ \hline
+\textbf{LEVEL}& \textbf{gdept\_1d}& \textbf{gdepw\_1d}& \textbf{e3t\_1d }& \textbf{e3w\_1d  } \\ \hline
 1	&	\textbf{  5.00}	&       0.00 &	\textbf{ 10.00} &	 10.00 \\	\hline
 2	&	\textbf{15.00}	& 	  10.00 &	\textbf{ 10.00} &	 10.00 \\	\hline
Index: branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_MISC.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_MISC.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_MISC.tex	(revision 9019)
@@ -2,5 +2,5 @@
 \begin{document}
 % ================================================================
-% Chapter ——— Miscellaneous Topics
+% Chapter --- Miscellaneous Topics
 % ================================================================
 \chapter{Miscellaneous Topics}
@@ -87,41 +87,8 @@
 
 % ================================================================
-% Sub-Domain Functionality (\textit{nizoom, njzoom}, namelist parameters)
-% ================================================================
-\section{Sub-Domain Functionality (\np{jpizoom}, \np{jpjzoom})}
+% Sub-Domain Functionality 
+% ================================================================
+\section{Sub-Domain Functionality}
 \label{MISC_zoom}
-
-The sub-domain functionality, also improperly called the zoom option 
-(improperly because it is not associated with a change in model resolution) 
-is a quite simple function that allows a simulation over a sub-domain of an 
-already defined configuration ($i.e.$ without defining a new mesh, initial 
-state and forcings). This option can be useful for testing the user settings 
-of surface boundary conditions, or the initial ocean state of a huge ocean 
-model configuration while having a small computer memory requirement. 
-It can also be used to easily test specific physics in a sub-domain (for example, 
-see \citep{Madec_al_JPO96} for a test of the coupling used in the global ocean 
-version of OPA between sea-ice and ocean model over the Arctic or Antarctic 
-ocean, using a sub-domain). In the standard model, this option does not 
-include any specific treatment for the ocean boundaries of the sub-domain: 
-they are considered as artificial vertical walls. Nevertheless, it is quite easy 
-to add a restoring term toward a climatology in the vicinity of such boundaries 
-(see \S\ref{TRA_dmp}).
-
-In order to easily define a sub-domain over which the computation can be 
-performed, the dimension of all input arrays (ocean mesh, bathymetry, 
-forcing, initial state, ...) are defined as \np{jpidta}, \np{jpjdta} and \np{jpkdta} 
-( in \ngn{namcfg} namelist), while the computational domain is defined through 
-\np{jpiglo}, \np{jpjglo} and \jp{jpk} (\ngn{namcfg} namelist). When running the 
-model over the whole domain, the user sets \np{jpiglo}=\np{jpidta} \np{jpjglo}=\np{jpjdta} 
-and \jp{jpk}=\jp{jpkdta}. When running the model over a sub-domain, the user 
-has to provide the size of the sub-domain, (\np{jpiglo}, \np{jpjglo}, \np{jpkglo}), 
-and the indices of the south western corner as \np{jpizoom} and \np{jpjzoom} in 
-the  \ngn{namcfg} namelist (Fig.~\ref{Fig_LBC_zoom}). 
-
-Note that a third set of dimensions exist, \jp{jpi}, \jp{jpj} and \jp{jpk} which is 
-actually used to perform the computation. It is set by default to \jp{jpi}=\np{jpjglo} 
-and \jp{jpj}=\np{jpjglo}, except for massively parallel computing where the 
-computational domain is laid out on local processor memories following a 2D 
-horizontal splitting. % (see {\S}IV.2-c) ref to the section to be updated
 
 \subsection{Simple subsetting of input files via netCDF attributes}
@@ -165,5 +132,5 @@
 \noindent Add the logical switch to \ngn{namcfg} in the configuration namelist and set true:
 %--------------------------------------------namcfg--------------------------------------------------------
-\namdisplay{namcfg_orca1}
+\namdisplay{namcfg}
 %--------------------------------------------------------------------------------------------------------------
 
Index: branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_SBC.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 9019)
@@ -1266,7 +1266,7 @@
 ice-ocean fluxes, that are combined with the air-sea fluxes using the ice fraction of 
 each model cell to provide the surface ocean fluxes. Note that the activation of a 
-sea-ice model is is done by defining a CPP key (\key{lim2}, \key{lim3} or \key{cice}). 
+sea-ice model is is done by defining a CPP key (\key{lim3} or \key{cice}). 
 The activation automatically overwrites the read value of nn{\_}ice to its appropriate 
-value ($i.e.$ $2$ for LIM-2, $3$ for LIM-3 or $4$ for CICE).
+value ($i.e.$ $2$ for LIM-3 or $3$ for CICE).
 \end{description}
 
Index: branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_ZDF.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_ZDF.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Chap_ZDF.tex	(revision 9019)
@@ -612,4 +612,15 @@
 Examples of performance of the 4 turbulent closure scheme can be found in \citet{Warner_al_OM05}.
 
+% -------------------------------------------------------------------------------------------------------------
+%        OSM OSMOSIS BL Scheme 
+% -------------------------------------------------------------------------------------------------------------
+\subsection{OSM OSMOSIS Boundary Layer scheme (\key{zdfosm})}
+\label{ZDF_osm}
+
+%--------------------------------------------namzdf_osm---------------------------------------------------------
+\namdisplay{namzdf_osm}
+%--------------------------------------------------------------------------------------------------------------
+
+The OSMOSIS turbulent closure scheme is based on......   TBC
 
 % ================================================================
@@ -734,5 +745,5 @@
 %       Turbulent Closure Scheme 
 % -------------------------------------------------------------------------------------------------------------
-\subsection{Turbulent Closure Scheme (\key{zdftke} or \key{zdfgls})}
+\subsection{Turbulent Closure Scheme (\key{zdftke}, \key{zdfgls} or \key{zdfosm})}
 \label{ZDF_tcs}
 
Index: branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Introduction.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Introduction.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Chapters/Introduction.tex	(revision 9019)
@@ -255,16 +255,16 @@
 $\bullet$ The main modifications from NEMO/OPA v3.4 and  v3.6 are :\\
 \begin{enumerate}
+ \item ... ; 
+\end{enumerate}
+
+
+ \vspace{1cm}
+$\bullet$ The main modifications from NEMO/OPA v3.6 and  v4.0 are :\\
+\begin{enumerate}
+\item new definition of configurations ;
+\item bulk formulation ;
 \item ... ; 
 \end{enumerate}
 
 
- \vspace{1cm}
-$\bullet$ The main modifications from NEMO/OPA v3.6 and  v4.0 are :\\
-\begin{enumerate}
-\item ... ; 
-
-
-\end{enumerate}
-
-
 \end{document}
Index: branches/2017/dev_merge_2017/DOC/TexFiles/Top_Matter.tex
===================================================================
--- branches/2017/dev_merge_2017/DOC/TexFiles/Top_Matter.tex	(revision 9018)
+++ branches/2017/dev_merge_2017/DOC/TexFiles/Top_Matter.tex	(revision 9019)
@@ -17,5 +17,5 @@
 %\date{\today}
 \date{
-January 2017  \\
+Decembre 2017  \\
 {\small  -- version 4.0 alpha --} \\
 ~  \\