Index: branches/UKMO/GO6_dyn_vrt_diag/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/UKMO/GO6_dyn_vrt_diag/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 8300)
+++ branches/UKMO/GO6_dyn_vrt_diag/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 9022)
@@ -499,25 +499,31 @@
         <field id="tke"          long_name="Turbulent Kinetic Energy"                  unit="m2/s2"    />
         <field id="tke_niw"      long_name="Turbulent Kinetic Energy due to near-inertial wave breaking"  unit="m2/s2" />
-        <!-- variables available with dyn_vrt_dia - available with TODO FLAGS and TODO FLAGS -->
-        <field id="dia_vor_int-hpg"    long_name="vertical integral vorticity tendencies for hpg"  standard_name="vertically_integrated_vorticity_tendencies_hpg"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-hpg"    long_name="vertical mean vorticity tendencies for hpg"  standard_name="vertical_mean_vorticity_tendencies_hpg"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-keg"    long_name="vertical integral vorticity tendencies for keg"  standard_name="vertically_integrated_vorticity_tendencies_keg"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-keg"    long_name="vertical mean vorticity tendencies for keg"  standard_name="vertical_mean_vorticity_tendencies_keg"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-ldf"    long_name="vertical integral vorticity tendencies for ldf"  standard_name="vertically_integrated_vorticity_tendencies_ldf"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-ldf"    long_name="vertical mean vorticity tendencies for ldf"  standard_name="vertical_mean_vorticity_tendencies_ldf"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-spg"    long_name="vertical integral vorticity tendencies for spg"  standard_name="vertically_integrated_vorticity_tendencies_spg"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-spg"    long_name="vertical mean vorticity tendencies for spg"  standard_name="vertical_mean_vorticity_tendencies_spg"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-rvo"    long_name="vertical integral vorticity tendencies for rvo"  standard_name="vertically_integrated_vorticity_tendencies_rvo"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-rvo"    long_name="vertical mean vorticity tendencies for rvo"  standard_name="vertical_mean_vorticity_tendencies_rvo"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-pvo"    long_name="vertical integral vorticity tendencies for pvo"  standard_name="vertically_integrated_vorticity_tendencies_pvo"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-pvo"    long_name="vertical mean vorticity tendencies for pvo"  standard_name="vertical_mean_vorticity_tendencies_pvo"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-zad"    long_name="vertical integral vorticity tendencies for zad"  standard_name="vertically_integrated_vorticity_tendencies_zad"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-zad"    long_name="vertical mean vorticity tendencies for zad"  standard_name="vertical_mean_vorticity_tendencies_zad"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-zdf"    long_name="vertical integral vorticity tendencies for zdf"  standard_name="vertically_integrated_vorticity_tendencies_zdf"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-zdf"    long_name="vertical mean vorticity tendencies for zdf"  standard_name="vertical_mean_vorticity_tendencies_zdf"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-bfr"    long_name="vertical integral vorticity tendencies for bfr"  standard_name="vertically_integrated_vorticity_tendencies_bfr"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-bfr"    long_name="vertical mean vorticity tendencies for bfr"  standard_name="vertical_mean_vorticity_tendencies_bfr"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_int-atf"    long_name="vertical integral vorticity tendencies for atf"  standard_name="vertically_integrated_vorticity_tendencies_atf"   unit="s-2"      grid_ref="grid_W_2D" />
-        <field id="dia_vor_mean-atf"    long_name="vertical mean vorticity tendencies for atf"  standard_name="vertical_mean_vorticity_tendencies_atf"   unit="s-2"      grid_ref="grid_W_2D" />
+        <!-- variables for trdvor output using ln_vor_trd -->
+        <!-- trdvor vertical average trends-->
+        <field id="sovortPh_avr"      long_name="averaged vertical average tendencies for pressure gradient trend"       standard_name="averaged_vor_grad_Ph"            unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovortEk_avr"      long_name="averaged vertical average tendencies for kinetic energy trend"          standard_name="averaged_vor_Energy"             unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovozeta_avr"      long_name="averaged vertical average tendencies for relative vorticity trend"      standard_name="averaged_vor_rel_vorticity"      unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovortif_avr"      long_name="averaged vertical average tendencies for coriolis trend"                standard_name="averaged_vor_coriolis"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovodifl_avr"      long_name="averaged vertical average tendencies for horizontal diffusion"          standard_name="averaged_vor_lat_diff"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovoadvv_avr"      long_name="averaged vertical average tendencies for vertical advection"            standard_name="averaged_vor_vert_adv"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovodifv_avr"      long_name="averaged vertical average tendencies for vertical diffusion"            standard_name="averaged_vor_vert_diff"          unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovortPs_avr"      long_name="averaged vertical average tendencies for surface pressure gradient"     standard_name="averaged_vor_grad_Ps"            unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovowind_avr"      long_name="averaged vertical average tendencies for wind stress"                   standard_name="averaged_vor_wind_stress"        unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovobfri_avr"      long_name="averaged vertical average tendencies for bottom friction"               standard_name="averaged_vor_bottom_friction"    unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="1st_mbre_avr"      long_name="averaged vertical average tendencies for 1st member of vrt eqn"         standard_name="averaged_vor_1st_mbre"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovorgap_avr"      long_name="averaged vertical average tendencies gap between 1st & 2nd member"      standard_name="averaged_vor_gap"                unit="s-2"      grid_ref="grid_W_2D" />
+        <!-- trdvor vertical integral trends-->
+        <field id="sovortPh_int"      long_name="averaged vertical integral tendencies for pressure gradient trend"      standard_name="integrated_vor_grad_Ph"            unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovortEk_int"      long_name="averaged vertical integral tendencies for kinetic energy trend"         standard_name="integrated_vor_Energy"             unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovozeta_int"      long_name="averaged vertical integral tendencies for relative vorticity trend"     standard_name="integrated_vor_rel_vorticity"      unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovortif_int"      long_name="averaged vertical integral tendencies for coriolis trend"               standard_name="integrated_vor_coriolis"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovodifl_int"      long_name="averaged vertical integral tendencies for horizontal diffusion"         standard_name="integrated_vor_lat_diff"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovoadvv_int"      long_name="averaged vertical integral tendencies for vertical advection"           standard_name="integrated_vor_vert_adv"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovodifv_int"      long_name="averaged vertical integral tendencies for vertical diffusion"           standard_name="integrated_vor_vert_diff"          unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovortPs_int"      long_name="averaged vertical integral tendencies for surface pressure gradient"    standard_name="integrated_vor_grad_Ps"            unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovowind_int"      long_name="averaged vertical integral tendencies for wind stress"                  standard_name="integrated_vor_wind_stress"        unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovobfri_int"      long_name="averaged vertical integral tendencies for bottom friction"              standard_name="integrated_vor_bottom_friction"    unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="1st_mbre_int"      long_name="averaged vertical integral tendencies for 1st member of vrt eqn"        standard_name="integrated_vor_1st_mbre"           unit="s-2"      grid_ref="grid_W_2D" />
+        <field id="sovorgap_int"      long_name="averaged vertical integral tendencies gap between 1st & 2nd member"     standard_name="integrated_vor_gap"                unit="s-2"      grid_ref="grid_W_2D" />
       </field_group>
           