Index: branches/2017/dev_merge_2017/NEMOGCM/SETTE/new_sette.sh
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/SETTE/new_sette.sh	(revision 9018)
+++ branches/2017/dev_merge_2017/NEMOGCM/SETTE/new_sette.sh	(revision 9025)
@@ -1101,7 +1101,7 @@
     set_namelist namelist_cfg ln_clobber .true.
     set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg ln_hpg_sco .false.
-    set_namelist namelist_cfg ln_hpg_zps .true.
+    set_namelist namelist_cfg ln_linssh .false.
+    set_namelist namelist_cfg ln_hpg_sco .true.
+    set_namelist namelist_cfg ln_hpg_zps .false.
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg jpni 2
@@ -1116,7 +1116,7 @@
     set_namelist 1_namelist_cfg ln_clobber .true.
     set_namelist 1_namelist_cfg ln_read_cfg .true.
-    set_namelist 1_namelist_cfg ln_linssh .true.
-    set_namelist 1_namelist_cfg ln_hpg_sco .false.
-    set_namelist 1_namelist_cfg ln_hpg_zps .true.
+    set_namelist 1_namelist_cfg ln_linssh .false.
+    set_namelist 1_namelist_cfg ln_hpg_sco .true.
+    set_namelist 1_namelist_cfg ln_hpg_zps .false.
 #
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -1140,7 +1140,7 @@
     set_namelist namelist_cfg ln_clobber .true.
     set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg ln_hpg_sco .false.
-    set_namelist namelist_cfg ln_hpg_zps .true.
+    set_namelist namelist_cfg ln_linssh .false.
+    set_namelist namelist_cfg ln_hpg_sco .true.
+    set_namelist namelist_cfg ln_hpg_zps .false.
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg jpni 2
@@ -1156,7 +1156,7 @@
     set_namelist 1_namelist_cfg ln_clobber .true.
     set_namelist 1_namelist_cfg ln_read_cfg .true.
-    set_namelist 1_namelist_cfg ln_linssh .true.
-    set_namelist 1_namelist_cfg ln_hpg_sco .false.
-    set_namelist 1_namelist_cfg ln_hpg_zps .true.
+    set_namelist 1_namelist_cfg ln_linssh .false.
+    set_namelist 1_namelist_cfg ln_hpg_sco .true.
+    set_namelist 1_namelist_cfg ln_hpg_zps .false.
     set_namelist namelist_cfg cn_ocerst_in \"O2LP_LONG_00000075_restart\"
     set_namelist namelist_ice_cfg cn_icerst_in \"O2LP_LONG_00000075_restart_ice\"
@@ -1198,7 +1198,7 @@
     set_namelist namelist_cfg ln_clobber .true.
     set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg ln_hpg_sco .false.
-    set_namelist namelist_cfg ln_hpg_zps .true.
+    set_namelist namelist_cfg ln_linssh .false.
+    set_namelist namelist_cfg ln_hpg_sco .true.
+    set_namelist namelist_cfg ln_hpg_zps .false.
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg jpni 4
@@ -1211,7 +1211,7 @@
     set_namelist 1_namelist_cfg ln_clobber .true.
     set_namelist 1_namelist_cfg ln_read_cfg .true.
-    set_namelist 1_namelist_cfg ln_linssh .true.
-    set_namelist 1_namelist_cfg ln_hpg_sco .false.
-    set_namelist 1_namelist_cfg ln_hpg_zps .true.
+    set_namelist 1_namelist_cfg ln_linssh .false.
+    set_namelist 1_namelist_cfg ln_hpg_sco .true.
+    set_namelist 1_namelist_cfg ln_hpg_zps .false.
 
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -1237,7 +1237,7 @@
     set_namelist namelist_cfg ln_clobber .true.
     set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg ln_hpg_sco .false.
-    set_namelist namelist_cfg ln_hpg_zps .true.
+    set_namelist namelist_cfg ln_linssh .false.
+    set_namelist namelist_cfg ln_hpg_sco .true.
+    set_namelist namelist_cfg ln_hpg_zps .false.
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg jpni 2
@@ -1250,7 +1250,7 @@
     set_namelist 1_namelist_cfg ln_clobber .true.
     set_namelist 1_namelist_cfg ln_read_cfg .true.
-    set_namelist 1_namelist_cfg ln_linssh .true.
-    set_namelist 1_namelist_cfg ln_hpg_sco .false.
-    set_namelist 1_namelist_cfg ln_hpg_zps .true.
+    set_namelist 1_namelist_cfg ln_linssh .false.
+    set_namelist 1_namelist_cfg ln_hpg_sco .true.
+    set_namelist 1_namelist_cfg ln_hpg_zps .false.
 
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -1285,7 +1285,7 @@
     set_namelist namelist_cfg ln_clobber .true.
     set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg ln_hpg_sco .false.
-    set_namelist namelist_cfg ln_hpg_zps .true. 
+    set_namelist namelist_cfg ln_linssh .false.
+    set_namelist namelist_cfg ln_hpg_sco .true.
+    set_namelist namelist_cfg ln_hpg_zps .false. 
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg jpni 2
@@ -1327,7 +1327,7 @@
     set_namelist namelist_cfg ln_clobber .true.
     set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg ln_linssh .true.
-    set_namelist namelist_cfg ln_hpg_sco .false.
-    set_namelist namelist_cfg ln_hpg_zps .true. 
+    set_namelist namelist_cfg ln_linssh .false.
+    set_namelist namelist_cfg ln_hpg_sco .true.
+    set_namelist namelist_cfg ln_hpg_zps .false. 
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg jpni 2