Index: branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90
===================================================================
--- branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 9009)
+++ branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 9032)
@@ -244,12 +244,12 @@
             IF (chl_out.eq.1) THEN
                !! export and scale surface chl
-               zn_chl_srf(:,:) = MAX( 0.0, (trn(:,:,1,jpchd) + trn(:,:,1,jpchn)) * scl_chl * 1.0E-6 )
+               zn_chl_srf(:,:) = MAX( 0.0, (trn(:,:,1,jpchd) + trn(:,:,1,jpchn)) * 1.0E-6 )
                                  !! surf Chl in Kg-chl/m3 as needed for cpl
             ELSEIF (chl_out.eq.2) THEN
                !! export and scale mld chl
-               zn_chl_srf(:,:) = MAX( 0.0, fchl_ml(:,:) * scl_chl * 1.0E-6 )
+               zn_chl_srf(:,:) = MAX( 0.0, fchl_ml(:,:) * 1.0E-6 )
                                  !! mld Chl in Kg-chl/m3 as needed for cpl
             ENDIF
-            chloro_out_cpl(:,:) = zn_chl_srf(:,:)        !! Coupling Chl
+            chloro_out_cpl(:,:) = zn_chl_srf(:,:) * scl_chl        !! Coupling Chl
          END IF
 
@@ -285,5 +285,5 @@
          ENDIF
          IF ( med_diag%CHL_CPL%dgsave ) THEN
-            CALL iom_put( "CHL_CPL"  , zn_chl_srf )
+            CALL iom_put( "CHL_CPL"  , chloro_out_cpl )
          ENDIF
          IF ( med_diag%PN_JLIM%dgsave ) THEN
Index: branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 9009)
+++ branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 9032)
@@ -271,5 +271,5 @@
       zn_dms_srf(:,:)  = 0.0
       za_dms_srf(:,:)  = 0.0
-      zn_chl_srf(:,:)  = 2.0E-8 * scl_chl !! Chl cpl - set first as surf
+      zn_chl_srf(:,:)  = 2.0E-8 !! Chl cpl - set first as surf
       !!
       IF(lwp) WRITE(numout,*) ' trc_ini_medusa: DMS and CO2 flux (UKESM) initialised to zero'
@@ -278,5 +278,5 @@
          CO2Flux_out_cpl(:,:) =  zn_co2_flx(:,:)   !! Coupling variable
          DMS_out_cpl(:,:)     =  zn_dms_srf(:,:)   !! Coupling variable
-         chloro_out_cpl(:,:)  =  zn_chl_srf(:,:)   !! Coupling variable
+         chloro_out_cpl(:,:)  =  zn_chl_srf(:,:) * scl_chl   !! Coupling variable
       END IF
       !!
Index: branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 9009)
+++ branches/NERC/dev_r5518_GO6_ScalingCoupledChl/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 9032)
@@ -284,11 +284,10 @@
          IF(lwp) WRITE(numout,*) 'Chl cpl concentration - reading in ... - scale by ', scl_chl
          CALL iom_get( numrtr, jpdom_autoglo, 'N_CHL_srf',  zn_chl_srf(:,:)  )
-         zn_chl_srf(:,:) =  zn_chl_srf(:,:) * scl_chl
       ELSE
          IF(lwp) WRITE(numout,*) 'set Chl coupled concentration - scaled by ', scl_chl
-         zn_chl_srf(:,:)  = MAX( 0.0, (trn(:,:,1,jpchn) + trn(:,:,1,jpchd)) * scl_chl * 1.E-6 )
+         zn_chl_srf(:,:)  = MAX( 0.0, (trn(:,:,1,jpchn) + trn(:,:,1,jpchd)) * 1.E-6 )
       ENDIF
       IF (lk_oasis) THEN
-         chloro_out_cpl(:,:) = zn_chl_srf(:,:)        !! Coupling variable
+         chloro_out_cpl(:,:) = zn_chl_srf(:,:) * scl_chl        !! Coupling variable
       END IF
       !!
@@ -302,5 +301,5 @@
       call trc_rst_dia_stat(zn_dms_srf(:,:), 'DMS surf')
       call trc_rst_dia_stat(zn_co2_flx(:,:), 'CO2 flux')
-      call trc_rst_dia_stat(zn_chl_srf(:,:), 'CHL  cpl')
+      call trc_rst_dia_stat(chloro_out_cpl(:,:), 'CHL  cpl')
       !!  
       !! JPALM 14-06-2016 -- add Carbonate chenistry variables through the restart
@@ -465,5 +464,4 @@
       !!                     unscaled Chl field in the restart and only 
       !!                     scale it when reading it in.
-      zn_chl_srf(:,:) = zn_chl_srf(:,:) / scl_chl 
       CALL iom_rstput( kt, nitrst, numrtw, 'N_CHL_srf',  zn_chl_srf(:,:)  )
       !!